-- (Example) Help Viewer for EDOM2
-- By Ralf Nieuwenhuijsen
----------------------------------
--  Readsin "edomhelp.edo" which contains a screen dump in ONE long sequence,
-- offcourse using EDOM2.

-- You can use the arrow keys up/down (or those on your keypad)
-- And you can use PageUP and PageDOWN
-- The escape key will bring you back to dos

-- USE AT OWN RISK (d'oh/duh)

    -- Includes
    include graphics.e      -- for cursor () 
    include get.e           -- for wait_key () (wait_key returns the idle to
    include edom.e                              -- OS when waiting)
    
    
    -- Constants        
    constant timage = edo_load ("edomhelp.edo",CP_NONE)
    constant screensize = 24 * 160              -- 24 lines by 2b per char
    constant maxoffset = length(timage) - screensize - 1286
    
    -- The -1 makes the EOF symbol visible in the most left of the statusbar 
    -- when you can't scroll any further, then it will dissapear when you
    -- scroll back up again.       
    
    -- Error checking
    if integer(timage) then
        puts(1,"\n Error occured! \n")
        puts(1, EDO_ERRORS[timage] & "\n\n")
        abort (timage)
    end if
    
    -- Locals
    integer key, offset
    sequence txt, msg

    -- Initializing
    clear_screen ()
    offset = 1                         
    txt = repeat(26, 159)   -- 26 is bcolor: darkblue fcolor: cyan
    msg = "(esc) quits (up/down) scrolls one line (pgup/pgdown) page forward/backward     " 

    -- Mixing txt with msg
    for j =1 to length(msg) do
        txt[j*2] = msg[j]
    end for
    -- txt is now like a screen dump: color-code; character
    
    cursor(#2000)   -- No cursor
    
    -- The display loop
    while 1 do                                             
        -- #B8000 is the offset of color text memory
        -- txt is the status line on the bottom
        poke (#B8000, timage[offset..offset+screensize] & txt)

        -- Get a key, and procces it!
        key = wait_key ()
        if key = 27 then exit end if                            -- ESCAPE
        if key = 328 then offset = offset - 160 end if          -- Arrow UP
        if key = 336 then offset = offset + 160 end if          -- Arrow DOWN
        if key = 337 then offset = offset + screensize end if   -- PageDOWN
        if key = 329 then offset = offset - screensize end if   -- PageUP
        
        -- Out of bouds check
        if offset > maxoffset then offset = maxoffset end if
        if offset < 1 then offset = 1 end if
        
    end while            
    
    -- Clear the screen with all the dirt
    clear_screen ()             
    
    -- Normal cursor
    cursor(#0507)   -- Normal MSDOS Cursor restored  

    -- Yeah, It's not the most clean way, I know.
    -- But its fast, small and I'm feeling kinda lazy..
    
    
    


