--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
-- Repeat_seq -- By Ralf Nieuwenhuijsen -- FreeWare -- 1998 =
--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
-- Repeats a sequence a number of times and smelts the pieces together..

-- There are three different ways to do this that I could come up with.
-- Suprisingly the most simple one is the fastest, even on very large seqs.
-- This is off course method 2: repeat_seq2
-- Althrough I think method 1 is the most interesting way and you would
    -- suspect this one to be the fastest, but I guess not...
    

    constant log2 = log(2)
    
    -- You would expect this one to be the fastest..
    global function repeat_seq1 (sequence o, integer i)
    sequence ret, a      
                
        ret = {}
        while i do
            a = o         
            for index = 1 to log (i) / log2 do
                a = a & a
            end for            
            i = i - length(a) / length(o)
            ret = ret & a
            if i = 1 then return ret & o end if
        end while
        
        return ret
    end function  
    
    -- Simple, basic algorithm, still it's the fastests way there is.
    global function repeat_seq2 (sequence o, integer i)
    sequence ret
    
        ret = {}
        for index = 1 to i do
            ret = ret & o
        end for

        return ret        
    end function  
    
    -- Extremely slow.. (Due to slicing, sequence () and [])
    global function repeat_seq3 (sequence o, integer i)
    
        o = repeat (o, i)
        while sequence(o[length(o)]) do
            o = o[length(o)] & o[1..length(o)-1]
        end while
        
        return o
    end function    

    sequence temp_s
    atom t
    t = time ()          
    for index = 1 to 10 do
        temp_s = repeat_seq1 ("Ralf", 100000)
    end for
    ? time () - t
    
    t = time ()
    for index = 1 to 10 do
        temp_s = repeat_seq2 ("Ralf", 100000)
    end for
    ? time () - t                                                   
    
    t = time ()
    for index = 1 to 10 do
        temp_s = repeat_seq3 ("Ralf", 1000)
    end for
    ? (time () - t) * 100
    

