--------------------------------------------------->> 
-- Speed testing of EDOM2 (by Ralf Nieuwenhuijsen)   
--------------------------------------------------->>

-- This file will test the speed of bytes & sequences.
-- It will load up library.doc and save it as temp.edo
 
-- Compression: Off
-- Structure Handling: Off
-- Sequence optimizing: Off

-- It's a speed test

    without type_check
    without warning

-- Use at own risk ! This is released in the public domain..

    include edom.e      
    
--<<.. This routine returns the contents of library.doc  ..>>

    function read_lib ()
    sequence ret, path
    integer fh
    
        -- Locating library.doc
        if sequence(getenv("EUDIR")) then
            path = getenv("EUDIR")
        else
            path = ""
        end if                 
        
        -- Opening library.doc
        fh = open (path & "\\doc\\library.doc","r")
        if fh = -1 then
            fh = open ("library.doc", "r")        
            if fh = -1 then
                puts(1,"\nCouldn't open library.doc\n")
                puts(1,"Make sure EUDIR is defined!\n\n")
                abort(1)
            end if
        end if
        
        -- Reading file into the private var 'ret'
        ret = gets(fh)
        while ret[length(ret)] + 1 do
            ret = ret & gets(fh)
        end while                      
        
        -- Return 'ret', without the EOF
        return ret[1..length(ret)-1]
    end function
    
--<<.. This routine times edo_save () ..>>

    procedure time_saving ()
    sequence txt
    integer dummy_i
    atom t
        
        -- The contents of library.doc --> txt
        txt = read_lib ()                     
        
        -- Warming up..                                  
        puts(1,"\n Please wait..\n")
        dummy_i = edo_save ("speed.edo", txt, CP_NONE)
        if dummy_i then
            puts(1, "\nError occured!\n\n")
            puts(1, ' ' & EDO_ERRORS[dummy_i] & '\n')   
            puts(1, "\n\nHas no use to continue\n")
            abort(dummy_i)
        end if
        
        -- Edo saving marathon..
        puts(1, "\n Saving library.doc 10 times [")
        t = time ()
        for j = 1 to 10 do
            dummy_i = edo_save ("speed.edo", txt, CP_NONE)
            puts(1, '.')
        end for    
        t = time() - t
        printf(1,"] in %2.1f s, with an average of %1.2f s\n",{t,t/10})
    end procedure
    
--<<.. This routine time edo_load () ..>>

    procedure time_loading ()
    object dummy_o
    atom t
    
        -- Warming up..
        puts(1,"\n Please wait..\n")
        dummy_o = edo_load ("speed.edo", CP_NONE)
        if integer(dummy_o) then
            puts(1, "\nError occured!\n\n")
            puts(1, ' ' & EDO_ERRORS[dummy_o] & '\n')   
            puts(1, "\nHas no use to continue\n")
            abort(dummy_o)
        end if
        
        -- Edo loading marathon..
        puts(1, "\n Loading  Speed.edo 10 times [")
        t = time ()
        for j = 1 to 10 do
            dummy_o = edo_load ("speed.edo", CP_NONE)
            puts(1, '.')
        end for    
        t = time() - t
        printf(1,"] in %2.1f s, with an average of %1.2f s\n",{t,t/10})
        
    end procedure

    -- Welcome message
    puts(1, "\n Timing EDOM2 by saving & loading library.doc \n")
    
    -- Time saving
    time_saving ()
    
    -- Time loading
    time_loading ()  
    
    -- End message
    puts(1, "\n Speed.edo has been created, and contains the library.doc\n\n")


